package mysql

import orm "duoduo/database"

type Order struct {
	CreateTime            string `gorm:"column:create_time" json:"createTime"`
	GoodsName             string `gorm:"column:goods_name" json:"goodsName"`
	GoodsThumbnailURL     string `gorm:"column:goods_thumbnail_url" json:"goodsThumbnailUrl"`
	JSONData              string `gorm:"column:json_data" json:"jsonData"`
	OrderGroupSuccessTime string `gorm:"column:order_group_success_time" json:"orderGroupSuccessTime"`
	OrderID               string `gorm:"column:order_id" json:"orderId"`
	OrderStatus           int    `gorm:"column:order_status" json:"orderStatus"`
	OrderStatusDesc       string `gorm:"column:order_status_desc" json:"orderStatusDesc"`
	PID                   string `gorm:"column:p_id" json:"pId"`
	PromotionAmount       int    `gorm:"column:promotion_amount" json:"promotionAmount"`
	UpdateTime            string `gorm:"column:update_time" json:"updateTime"`
}

// TableName sets the insert table name for this struct type
func (o *Order) TableName() string {
	return "order"
}

func (o *Order) Create() (Order, error) {
	var doc Order
	result := orm.Eloquent.Table(o.TableName()).Create(&o)
	if result.Error != nil {
		err := result.Error
		return doc, err
	}
	doc = *o
	return doc, nil
}

func (o *Order) GetNum() int {
	var count int
	tableCount := orm.Eloquent.Table(o.TableName()).Where("order_id = ? ", o.OrderID)
	tableCount.Count(&count)
	return count
}

// 更新
func (o *Order) Update(orderId string) (update Order, err error) {
	if err = orm.Eloquent.Table(o.TableName()).Where("order_id = ?", orderId).First(&update).Error; err != nil {
		return
	}

	//参数1:是要修改的数据
	//参数2:是修改的数据
	if err = orm.Eloquent.Table(o.TableName()).Model(&update).Updates(&o).Error; err != nil {
		return
	}
	return
}
